# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from mir_actions/MirMoveBaseAction.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import actionlib_msgs.msg
import genpy
import geometry_msgs.msg
import mir_actions.msg
import mir_msgs.msg
import nav_msgs.msg
import std_msgs.msg

class MirMoveBaseAction(genpy.Message):
  _md5sum = "0ed52f96e28b63ff15853a6b2114fe93"
  _type = "mir_actions/MirMoveBaseAction"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

MirMoveBaseActionGoal action_goal
MirMoveBaseActionResult action_result
MirMoveBaseActionFeedback action_feedback

================================================================================
MSG: mir_actions/MirMoveBaseActionGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalID goal_id
MirMoveBaseGoal goal

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: mir_actions/MirMoveBaseGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
#goal definition
#move type
int16 BASE_MOVE = 0
int16 GLOBAL_MOVE = 1
int16 RELATIVE_MOVE = 2
int16 RELATIVE_MARKER_MOVE = 3
int16 DOCKING_MOVE = 4
int16 DOCKING_GLOBAL_MOVE = 5
int16 PATH_TYPE = 6
int16 move_task

#shared parameters
geometry_msgs/PoseStamped target_pose
string target_guid

#global move parameters
float64 goal_dist_threshold
float64 goal_orientation_threshold
nav_msgs/Path path
float32 max_plan_time
bool clear_costmaps
bool pause_command
bool continue_command

#relative move parameters
float64 yaw
bool collision_detection
bool collision_avoidance
float64 disable_collision_check_dist
float64 max_linear_speed
float64 max_rotational_speed
float64 pid_dist_offset
float64 target_offset
bool only_collision_detection
float64 timeout

#docking move parameters
int32 pattern_type
int32 pattern_value
bool only_track
bool same_goal
string pose_frame
geometry_msgs/Pose2D pose
geometry_msgs/Pose2D offset
float64 bar_length
float64 bar_distance
float64 shelf_leg_asymmetry_x
float64 tolerance

#Path type
mir_msgs/MirLocalPlannerPathTypes path_type
geometry_msgs/PoseStamped start_pose
# float64 timeout



================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: nav_msgs/Path
#An array of poses that represents a Path for a robot to follow
Header header
geometry_msgs/PoseStamped[] poses

================================================================================
MSG: geometry_msgs/Pose2D
# Deprecated
# Please use the full 3D pose.

# In general our recommendation is to use a full 3D representation of everything and for 2D specific applications make the appropriate projections into the plane for their calculations but optimally will preserve the 3D information during processing.

# If we have parallel copies of 2D datatypes every UI and other pipeline will end up needing to have dual interfaces to plot everything. And you will end up with not being able to use 3D tools for 2D use cases even if they're completely valid, as you'd have to reimplement it with different inputs and outputs. It's not particularly hard to plot the 2D pose or compute the yaw error for the Pose message and there are already tools and libraries that can do this for you.


# This expresses a position and orientation on a 2D manifold.

float64 x
float64 y
float64 theta

================================================================================
MSG: mir_msgs/MirLocalPlannerPathTypes
uint8 REVERSE_TROLLEY_STANDARD=1
uint8 REVERSE_TROLLEY_FAST=2
uint8 REVERSE_TROLLEY_COMPACT=3


uint8 path_type

================================================================================
MSG: mir_actions/MirMoveBaseActionResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
MirMoveBaseResult result

================================================================================
MSG: actionlib_msgs/GoalStatus
GoalID goal_id
uint8 status
uint8 PENDING         = 0   # The goal has yet to be processed by the action server
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                            #   and has since completed its execution (Terminal State)
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                            #    to some failure (Terminal State)
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                            #    because the goal was unattainable or invalid (Terminal State)
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                            #    and has not yet completed execution
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                            #    but the action server has not yet confirmed that the goal is canceled
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                            #    and was successfully cancelled (Terminal State)
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                            #    sent over the wire by an action server

#Allow for the user to associate a string with GoalStatus for debugging
string text


================================================================================
MSG: mir_actions/MirMoveBaseResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
#result definition

#shared states
int16 UNDEFINED = 0
int16 GOAL_REACHED = 1
int16 FAILED = -1

#global move states
int16 MARKER_VISIBLE = 2
int16 FAILED_NO_PATH = -2
int16 FAILED_GOAL_IN_STATIC_OBSTACLE = -3
int16 FAILED_GOAL_IN_FORBIDDEN_AREA = -4
int16 FAILED_GOAL_IN_DYNAMIC_OBSTACLE = -5
int16 FAILED_ROBOT_IN_COLLISION = -6
int16 FAILED_ROBOT_IN_FORBIDDEN_AREA = -7
int16 FAILED_UNKNOWN_TRAILER = -8
int16 FAILED_TO_PASS_GLOBAL_PLAN = -9
int16 FAILED_NO_VALID_RECOVERY_CONTROL = -10
int16 FAILED_UNKNOWN_PLANNER_ERROR = -11
int16 FAILED_ROBOT_OSCILLATING = -12
int16 FAILED_SOFTWARE_ERROR = -13

#relative move states
int16 FAILED_TIMEOUT = -14
int16 FAILED_COLLISION = -15
int16 INVALID_GOAL = -16

#docking move states
int16 FAILED_MARKER_TRACKING_ERROR = -17

#shared results
int16 end_state
geometry_msgs/PoseStamped end_pose

#docking results
geometry_msgs/Pose2D pose

#feedback for UI
string message


================================================================================
MSG: mir_actions/MirMoveBaseActionFeedback
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
MirMoveBaseFeedback feedback

================================================================================
MSG: mir_actions/MirMoveBaseFeedback
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
#feedback
#shared
int8 NOT_READY = -1
int8 UNKNOWN = -2
int8 WAITING_FOR_FLEET = -3
int8 COLLISION = -4

#global move states
int8 PLANNING = 0
int8 CONTROLLING = 1
int8 CLEARING = 2

#relative move states
int8 DOCKING = 3

#shared feedback
int8 state

#global move feedback
geometry_msgs/PoseStamped base_position

#relative move feedback
geometry_msgs/PoseStamped current_goal
geometry_msgs/PoseStamped dist_to_goal

#docking move feedback
geometry_msgs/Pose2D pose
bool marker_inversion

#path_types
    #reverse_trolly
int8 MOVING_FORWARD = 10
int8 MOVING_BACKWARD = 11

"""
  __slots__ = ['action_goal','action_result','action_feedback']
  _slot_types = ['mir_actions/MirMoveBaseActionGoal','mir_actions/MirMoveBaseActionResult','mir_actions/MirMoveBaseActionFeedback']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       action_goal,action_result,action_feedback

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MirMoveBaseAction, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.action_goal is None:
        self.action_goal = mir_actions.msg.MirMoveBaseActionGoal()
      if self.action_result is None:
        self.action_result = mir_actions.msg.MirMoveBaseActionResult()
      if self.action_feedback is None:
        self.action_feedback = mir_actions.msg.MirMoveBaseActionFeedback()
    else:
      self.action_goal = mir_actions.msg.MirMoveBaseActionGoal()
      self.action_result = mir_actions.msg.MirMoveBaseActionResult()
      self.action_feedback = mir_actions.msg.MirMoveBaseActionFeedback()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.action_goal.header.seq, _x.action_goal.header.stamp.secs, _x.action_goal.header.stamp.nsecs))
      _x = self.action_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.action_goal.goal_id.stamp.secs, _x.action_goal.goal_id.stamp.nsecs))
      _x = self.action_goal.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_h3I().pack(_x.action_goal.goal.move_task, _x.action_goal.goal.target_pose.header.seq, _x.action_goal.goal.target_pose.header.stamp.secs, _x.action_goal.goal.target_pose.header.stamp.nsecs))
      _x = self.action_goal.goal.target_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.action_goal.goal.target_pose.pose.position.x, _x.action_goal.goal.target_pose.pose.position.y, _x.action_goal.goal.target_pose.pose.position.z, _x.action_goal.goal.target_pose.pose.orientation.x, _x.action_goal.goal.target_pose.pose.orientation.y, _x.action_goal.goal.target_pose.pose.orientation.z, _x.action_goal.goal.target_pose.pose.orientation.w))
      _x = self.action_goal.goal.target_guid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2d3I().pack(_x.action_goal.goal.goal_dist_threshold, _x.action_goal.goal.goal_orientation_threshold, _x.action_goal.goal.path.header.seq, _x.action_goal.goal.path.header.stamp.secs, _x.action_goal.goal.path.header.stamp.nsecs))
      _x = self.action_goal.goal.path.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.action_goal.goal.path.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.path.poses:
        _v1 = val1.header
        _x = _v1.seq
        buff.write(_get_struct_I().pack(_x))
        _v2 = _v1.stamp
        _x = _v2
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v1.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v3 = val1.pose
        _v4 = _v3.position
        _x = _v4
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v5 = _v3.orientation
        _x = _v5
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_get_struct_f3Bd2B5dBd2i2B().pack(_x.action_goal.goal.max_plan_time, _x.action_goal.goal.clear_costmaps, _x.action_goal.goal.pause_command, _x.action_goal.goal.continue_command, _x.action_goal.goal.yaw, _x.action_goal.goal.collision_detection, _x.action_goal.goal.collision_avoidance, _x.action_goal.goal.disable_collision_check_dist, _x.action_goal.goal.max_linear_speed, _x.action_goal.goal.max_rotational_speed, _x.action_goal.goal.pid_dist_offset, _x.action_goal.goal.target_offset, _x.action_goal.goal.only_collision_detection, _x.action_goal.goal.timeout, _x.action_goal.goal.pattern_type, _x.action_goal.goal.pattern_value, _x.action_goal.goal.only_track, _x.action_goal.goal.same_goal))
      _x = self.action_goal.goal.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10dB3I().pack(_x.action_goal.goal.pose.x, _x.action_goal.goal.pose.y, _x.action_goal.goal.pose.theta, _x.action_goal.goal.offset.x, _x.action_goal.goal.offset.y, _x.action_goal.goal.offset.theta, _x.action_goal.goal.bar_length, _x.action_goal.goal.bar_distance, _x.action_goal.goal.shelf_leg_asymmetry_x, _x.action_goal.goal.tolerance, _x.action_goal.goal.path_type.path_type, _x.action_goal.goal.start_pose.header.seq, _x.action_goal.goal.start_pose.header.stamp.secs, _x.action_goal.goal.start_pose.header.stamp.nsecs))
      _x = self.action_goal.goal.start_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d3I().pack(_x.action_goal.goal.start_pose.pose.position.x, _x.action_goal.goal.start_pose.pose.position.y, _x.action_goal.goal.start_pose.pose.position.z, _x.action_goal.goal.start_pose.pose.orientation.x, _x.action_goal.goal.start_pose.pose.orientation.y, _x.action_goal.goal.start_pose.pose.orientation.z, _x.action_goal.goal.start_pose.pose.orientation.w, _x.action_result.header.seq, _x.action_result.header.stamp.secs, _x.action_result.header.stamp.nsecs))
      _x = self.action_result.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.action_result.status.goal_id.stamp.secs, _x.action_result.status.goal_id.stamp.nsecs))
      _x = self.action_result.status.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.action_result.status.status
      buff.write(_get_struct_B().pack(_x))
      _x = self.action_result.status.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_h3I().pack(_x.action_result.result.end_state, _x.action_result.result.end_pose.header.seq, _x.action_result.result.end_pose.header.stamp.secs, _x.action_result.result.end_pose.header.stamp.nsecs))
      _x = self.action_result.result.end_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10d().pack(_x.action_result.result.end_pose.pose.position.x, _x.action_result.result.end_pose.pose.position.y, _x.action_result.result.end_pose.pose.position.z, _x.action_result.result.end_pose.pose.orientation.x, _x.action_result.result.end_pose.pose.orientation.y, _x.action_result.result.end_pose.pose.orientation.z, _x.action_result.result.end_pose.pose.orientation.w, _x.action_result.result.pose.x, _x.action_result.result.pose.y, _x.action_result.result.pose.theta))
      _x = self.action_result.result.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.action_feedback.header.seq, _x.action_feedback.header.stamp.secs, _x.action_feedback.header.stamp.nsecs))
      _x = self.action_feedback.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.action_feedback.status.goal_id.stamp.secs, _x.action_feedback.status.goal_id.stamp.nsecs))
      _x = self.action_feedback.status.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.action_feedback.status.status
      buff.write(_get_struct_B().pack(_x))
      _x = self.action_feedback.status.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_b3I().pack(_x.action_feedback.feedback.state, _x.action_feedback.feedback.base_position.header.seq, _x.action_feedback.feedback.base_position.header.stamp.secs, _x.action_feedback.feedback.base_position.header.stamp.nsecs))
      _x = self.action_feedback.feedback.base_position.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d3I().pack(_x.action_feedback.feedback.base_position.pose.position.x, _x.action_feedback.feedback.base_position.pose.position.y, _x.action_feedback.feedback.base_position.pose.position.z, _x.action_feedback.feedback.base_position.pose.orientation.x, _x.action_feedback.feedback.base_position.pose.orientation.y, _x.action_feedback.feedback.base_position.pose.orientation.z, _x.action_feedback.feedback.base_position.pose.orientation.w, _x.action_feedback.feedback.current_goal.header.seq, _x.action_feedback.feedback.current_goal.header.stamp.secs, _x.action_feedback.feedback.current_goal.header.stamp.nsecs))
      _x = self.action_feedback.feedback.current_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d3I().pack(_x.action_feedback.feedback.current_goal.pose.position.x, _x.action_feedback.feedback.current_goal.pose.position.y, _x.action_feedback.feedback.current_goal.pose.position.z, _x.action_feedback.feedback.current_goal.pose.orientation.x, _x.action_feedback.feedback.current_goal.pose.orientation.y, _x.action_feedback.feedback.current_goal.pose.orientation.z, _x.action_feedback.feedback.current_goal.pose.orientation.w, _x.action_feedback.feedback.dist_to_goal.header.seq, _x.action_feedback.feedback.dist_to_goal.header.stamp.secs, _x.action_feedback.feedback.dist_to_goal.header.stamp.nsecs))
      _x = self.action_feedback.feedback.dist_to_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10dB().pack(_x.action_feedback.feedback.dist_to_goal.pose.position.x, _x.action_feedback.feedback.dist_to_goal.pose.position.y, _x.action_feedback.feedback.dist_to_goal.pose.position.z, _x.action_feedback.feedback.dist_to_goal.pose.orientation.x, _x.action_feedback.feedback.dist_to_goal.pose.orientation.y, _x.action_feedback.feedback.dist_to_goal.pose.orientation.z, _x.action_feedback.feedback.dist_to_goal.pose.orientation.w, _x.action_feedback.feedback.pose.x, _x.action_feedback.feedback.pose.y, _x.action_feedback.feedback.pose.theta, _x.action_feedback.feedback.marker_inversion))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.action_goal is None:
        self.action_goal = mir_actions.msg.MirMoveBaseActionGoal()
      if self.action_result is None:
        self.action_result = mir_actions.msg.MirMoveBaseActionResult()
      if self.action_feedback is None:
        self.action_feedback = mir_actions.msg.MirMoveBaseActionFeedback()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.action_goal.header.seq, _x.action_goal.header.stamp.secs, _x.action_goal.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal_id.stamp.secs, _x.action_goal.goal_id.stamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal_id.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_goal.goal_id.id = str[start:end]
      _x = self
      start = end
      end += 14
      (_x.action_goal.goal.move_task, _x.action_goal.goal.target_pose.header.seq, _x.action_goal.goal.target_pose.header.stamp.secs, _x.action_goal.goal.target_pose.header.stamp.nsecs,) = _get_struct_h3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_goal.goal.target_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.action_goal.goal.target_pose.pose.position.x, _x.action_goal.goal.target_pose.pose.position.y, _x.action_goal.goal.target_pose.pose.position.z, _x.action_goal.goal.target_pose.pose.orientation.x, _x.action_goal.goal.target_pose.pose.orientation.y, _x.action_goal.goal.target_pose.pose.orientation.z, _x.action_goal.goal.target_pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target_guid = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_goal.goal.target_guid = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.action_goal.goal.goal_dist_threshold, _x.action_goal.goal.goal_orientation_threshold, _x.action_goal.goal.path.header.seq, _x.action_goal.goal.path.header.stamp.secs, _x.action_goal.goal.path.header.stamp.nsecs,) = _get_struct_2d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.path.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_goal.goal.path.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.path.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.PoseStamped()
        _v6 = val1.header
        start = end
        end += 4
        (_v6.seq,) = _get_struct_I().unpack(str[start:end])
        _v7 = _v6.stamp
        _x = _v7
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v6.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v6.frame_id = str[start:end]
        _v8 = val1.pose
        _v9 = _v8.position
        _x = _v9
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v10 = _v8.orientation
        _x = _v10
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.action_goal.goal.path.poses.append(val1)
      _x = self
      start = end
      end += 76
      (_x.action_goal.goal.max_plan_time, _x.action_goal.goal.clear_costmaps, _x.action_goal.goal.pause_command, _x.action_goal.goal.continue_command, _x.action_goal.goal.yaw, _x.action_goal.goal.collision_detection, _x.action_goal.goal.collision_avoidance, _x.action_goal.goal.disable_collision_check_dist, _x.action_goal.goal.max_linear_speed, _x.action_goal.goal.max_rotational_speed, _x.action_goal.goal.pid_dist_offset, _x.action_goal.goal.target_offset, _x.action_goal.goal.only_collision_detection, _x.action_goal.goal.timeout, _x.action_goal.goal.pattern_type, _x.action_goal.goal.pattern_value, _x.action_goal.goal.only_track, _x.action_goal.goal.same_goal,) = _get_struct_f3Bd2B5dBd2i2B().unpack(str[start:end])
      self.action_goal.goal.clear_costmaps = bool(self.action_goal.goal.clear_costmaps)
      self.action_goal.goal.pause_command = bool(self.action_goal.goal.pause_command)
      self.action_goal.goal.continue_command = bool(self.action_goal.goal.continue_command)
      self.action_goal.goal.collision_detection = bool(self.action_goal.goal.collision_detection)
      self.action_goal.goal.collision_avoidance = bool(self.action_goal.goal.collision_avoidance)
      self.action_goal.goal.only_collision_detection = bool(self.action_goal.goal.only_collision_detection)
      self.action_goal.goal.only_track = bool(self.action_goal.goal.only_track)
      self.action_goal.goal.same_goal = bool(self.action_goal.goal.same_goal)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.pose_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_goal.goal.pose_frame = str[start:end]
      _x = self
      start = end
      end += 93
      (_x.action_goal.goal.pose.x, _x.action_goal.goal.pose.y, _x.action_goal.goal.pose.theta, _x.action_goal.goal.offset.x, _x.action_goal.goal.offset.y, _x.action_goal.goal.offset.theta, _x.action_goal.goal.bar_length, _x.action_goal.goal.bar_distance, _x.action_goal.goal.shelf_leg_asymmetry_x, _x.action_goal.goal.tolerance, _x.action_goal.goal.path_type.path_type, _x.action_goal.goal.start_pose.header.seq, _x.action_goal.goal.start_pose.header.stamp.secs, _x.action_goal.goal.start_pose.header.stamp.nsecs,) = _get_struct_10dB3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.start_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_goal.goal.start_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.action_goal.goal.start_pose.pose.position.x, _x.action_goal.goal.start_pose.pose.position.y, _x.action_goal.goal.start_pose.pose.position.z, _x.action_goal.goal.start_pose.pose.orientation.x, _x.action_goal.goal.start_pose.pose.orientation.y, _x.action_goal.goal.start_pose.pose.orientation.z, _x.action_goal.goal.start_pose.pose.orientation.w, _x.action_result.header.seq, _x.action_result.header.stamp.secs, _x.action_result.header.stamp.nsecs,) = _get_struct_7d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_result.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_result.status.goal_id.stamp.secs, _x.action_result.status.goal_id.stamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.status.goal_id.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_result.status.goal_id.id = str[start:end]
      start = end
      end += 1
      (self.action_result.status.status,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.status.text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_result.status.text = str[start:end]
      _x = self
      start = end
      end += 14
      (_x.action_result.result.end_state, _x.action_result.result.end_pose.header.seq, _x.action_result.result.end_pose.header.stamp.secs, _x.action_result.result.end_pose.header.stamp.nsecs,) = _get_struct_h3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.result.end_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_result.result.end_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.action_result.result.end_pose.pose.position.x, _x.action_result.result.end_pose.pose.position.y, _x.action_result.result.end_pose.pose.position.z, _x.action_result.result.end_pose.pose.orientation.x, _x.action_result.result.end_pose.pose.orientation.y, _x.action_result.result.end_pose.pose.orientation.z, _x.action_result.result.end_pose.pose.orientation.w, _x.action_result.result.pose.x, _x.action_result.result.pose.y, _x.action_result.result.pose.theta,) = _get_struct_10d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.result.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_result.result.message = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.action_feedback.header.seq, _x.action_feedback.header.stamp.secs, _x.action_feedback.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_feedback.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_feedback.status.goal_id.stamp.secs, _x.action_feedback.status.goal_id.stamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.status.goal_id.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_feedback.status.goal_id.id = str[start:end]
      start = end
      end += 1
      (self.action_feedback.status.status,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.status.text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_feedback.status.text = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.action_feedback.feedback.state, _x.action_feedback.feedback.base_position.header.seq, _x.action_feedback.feedback.base_position.header.stamp.secs, _x.action_feedback.feedback.base_position.header.stamp.nsecs,) = _get_struct_b3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.feedback.base_position.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_feedback.feedback.base_position.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.action_feedback.feedback.base_position.pose.position.x, _x.action_feedback.feedback.base_position.pose.position.y, _x.action_feedback.feedback.base_position.pose.position.z, _x.action_feedback.feedback.base_position.pose.orientation.x, _x.action_feedback.feedback.base_position.pose.orientation.y, _x.action_feedback.feedback.base_position.pose.orientation.z, _x.action_feedback.feedback.base_position.pose.orientation.w, _x.action_feedback.feedback.current_goal.header.seq, _x.action_feedback.feedback.current_goal.header.stamp.secs, _x.action_feedback.feedback.current_goal.header.stamp.nsecs,) = _get_struct_7d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.feedback.current_goal.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_feedback.feedback.current_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.action_feedback.feedback.current_goal.pose.position.x, _x.action_feedback.feedback.current_goal.pose.position.y, _x.action_feedback.feedback.current_goal.pose.position.z, _x.action_feedback.feedback.current_goal.pose.orientation.x, _x.action_feedback.feedback.current_goal.pose.orientation.y, _x.action_feedback.feedback.current_goal.pose.orientation.z, _x.action_feedback.feedback.current_goal.pose.orientation.w, _x.action_feedback.feedback.dist_to_goal.header.seq, _x.action_feedback.feedback.dist_to_goal.header.stamp.secs, _x.action_feedback.feedback.dist_to_goal.header.stamp.nsecs,) = _get_struct_7d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.feedback.dist_to_goal.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_feedback.feedback.dist_to_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 81
      (_x.action_feedback.feedback.dist_to_goal.pose.position.x, _x.action_feedback.feedback.dist_to_goal.pose.position.y, _x.action_feedback.feedback.dist_to_goal.pose.position.z, _x.action_feedback.feedback.dist_to_goal.pose.orientation.x, _x.action_feedback.feedback.dist_to_goal.pose.orientation.y, _x.action_feedback.feedback.dist_to_goal.pose.orientation.z, _x.action_feedback.feedback.dist_to_goal.pose.orientation.w, _x.action_feedback.feedback.pose.x, _x.action_feedback.feedback.pose.y, _x.action_feedback.feedback.pose.theta, _x.action_feedback.feedback.marker_inversion,) = _get_struct_10dB().unpack(str[start:end])
      self.action_feedback.feedback.marker_inversion = bool(self.action_feedback.feedback.marker_inversion)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.action_goal.header.seq, _x.action_goal.header.stamp.secs, _x.action_goal.header.stamp.nsecs))
      _x = self.action_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.action_goal.goal_id.stamp.secs, _x.action_goal.goal_id.stamp.nsecs))
      _x = self.action_goal.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_h3I().pack(_x.action_goal.goal.move_task, _x.action_goal.goal.target_pose.header.seq, _x.action_goal.goal.target_pose.header.stamp.secs, _x.action_goal.goal.target_pose.header.stamp.nsecs))
      _x = self.action_goal.goal.target_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.action_goal.goal.target_pose.pose.position.x, _x.action_goal.goal.target_pose.pose.position.y, _x.action_goal.goal.target_pose.pose.position.z, _x.action_goal.goal.target_pose.pose.orientation.x, _x.action_goal.goal.target_pose.pose.orientation.y, _x.action_goal.goal.target_pose.pose.orientation.z, _x.action_goal.goal.target_pose.pose.orientation.w))
      _x = self.action_goal.goal.target_guid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2d3I().pack(_x.action_goal.goal.goal_dist_threshold, _x.action_goal.goal.goal_orientation_threshold, _x.action_goal.goal.path.header.seq, _x.action_goal.goal.path.header.stamp.secs, _x.action_goal.goal.path.header.stamp.nsecs))
      _x = self.action_goal.goal.path.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.action_goal.goal.path.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.path.poses:
        _v11 = val1.header
        _x = _v11.seq
        buff.write(_get_struct_I().pack(_x))
        _v12 = _v11.stamp
        _x = _v12
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v11.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v13 = val1.pose
        _v14 = _v13.position
        _x = _v14
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v15 = _v13.orientation
        _x = _v15
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_get_struct_f3Bd2B5dBd2i2B().pack(_x.action_goal.goal.max_plan_time, _x.action_goal.goal.clear_costmaps, _x.action_goal.goal.pause_command, _x.action_goal.goal.continue_command, _x.action_goal.goal.yaw, _x.action_goal.goal.collision_detection, _x.action_goal.goal.collision_avoidance, _x.action_goal.goal.disable_collision_check_dist, _x.action_goal.goal.max_linear_speed, _x.action_goal.goal.max_rotational_speed, _x.action_goal.goal.pid_dist_offset, _x.action_goal.goal.target_offset, _x.action_goal.goal.only_collision_detection, _x.action_goal.goal.timeout, _x.action_goal.goal.pattern_type, _x.action_goal.goal.pattern_value, _x.action_goal.goal.only_track, _x.action_goal.goal.same_goal))
      _x = self.action_goal.goal.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10dB3I().pack(_x.action_goal.goal.pose.x, _x.action_goal.goal.pose.y, _x.action_goal.goal.pose.theta, _x.action_goal.goal.offset.x, _x.action_goal.goal.offset.y, _x.action_goal.goal.offset.theta, _x.action_goal.goal.bar_length, _x.action_goal.goal.bar_distance, _x.action_goal.goal.shelf_leg_asymmetry_x, _x.action_goal.goal.tolerance, _x.action_goal.goal.path_type.path_type, _x.action_goal.goal.start_pose.header.seq, _x.action_goal.goal.start_pose.header.stamp.secs, _x.action_goal.goal.start_pose.header.stamp.nsecs))
      _x = self.action_goal.goal.start_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d3I().pack(_x.action_goal.goal.start_pose.pose.position.x, _x.action_goal.goal.start_pose.pose.position.y, _x.action_goal.goal.start_pose.pose.position.z, _x.action_goal.goal.start_pose.pose.orientation.x, _x.action_goal.goal.start_pose.pose.orientation.y, _x.action_goal.goal.start_pose.pose.orientation.z, _x.action_goal.goal.start_pose.pose.orientation.w, _x.action_result.header.seq, _x.action_result.header.stamp.secs, _x.action_result.header.stamp.nsecs))
      _x = self.action_result.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.action_result.status.goal_id.stamp.secs, _x.action_result.status.goal_id.stamp.nsecs))
      _x = self.action_result.status.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.action_result.status.status
      buff.write(_get_struct_B().pack(_x))
      _x = self.action_result.status.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_h3I().pack(_x.action_result.result.end_state, _x.action_result.result.end_pose.header.seq, _x.action_result.result.end_pose.header.stamp.secs, _x.action_result.result.end_pose.header.stamp.nsecs))
      _x = self.action_result.result.end_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10d().pack(_x.action_result.result.end_pose.pose.position.x, _x.action_result.result.end_pose.pose.position.y, _x.action_result.result.end_pose.pose.position.z, _x.action_result.result.end_pose.pose.orientation.x, _x.action_result.result.end_pose.pose.orientation.y, _x.action_result.result.end_pose.pose.orientation.z, _x.action_result.result.end_pose.pose.orientation.w, _x.action_result.result.pose.x, _x.action_result.result.pose.y, _x.action_result.result.pose.theta))
      _x = self.action_result.result.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.action_feedback.header.seq, _x.action_feedback.header.stamp.secs, _x.action_feedback.header.stamp.nsecs))
      _x = self.action_feedback.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.action_feedback.status.goal_id.stamp.secs, _x.action_feedback.status.goal_id.stamp.nsecs))
      _x = self.action_feedback.status.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.action_feedback.status.status
      buff.write(_get_struct_B().pack(_x))
      _x = self.action_feedback.status.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_b3I().pack(_x.action_feedback.feedback.state, _x.action_feedback.feedback.base_position.header.seq, _x.action_feedback.feedback.base_position.header.stamp.secs, _x.action_feedback.feedback.base_position.header.stamp.nsecs))
      _x = self.action_feedback.feedback.base_position.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d3I().pack(_x.action_feedback.feedback.base_position.pose.position.x, _x.action_feedback.feedback.base_position.pose.position.y, _x.action_feedback.feedback.base_position.pose.position.z, _x.action_feedback.feedback.base_position.pose.orientation.x, _x.action_feedback.feedback.base_position.pose.orientation.y, _x.action_feedback.feedback.base_position.pose.orientation.z, _x.action_feedback.feedback.base_position.pose.orientation.w, _x.action_feedback.feedback.current_goal.header.seq, _x.action_feedback.feedback.current_goal.header.stamp.secs, _x.action_feedback.feedback.current_goal.header.stamp.nsecs))
      _x = self.action_feedback.feedback.current_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d3I().pack(_x.action_feedback.feedback.current_goal.pose.position.x, _x.action_feedback.feedback.current_goal.pose.position.y, _x.action_feedback.feedback.current_goal.pose.position.z, _x.action_feedback.feedback.current_goal.pose.orientation.x, _x.action_feedback.feedback.current_goal.pose.orientation.y, _x.action_feedback.feedback.current_goal.pose.orientation.z, _x.action_feedback.feedback.current_goal.pose.orientation.w, _x.action_feedback.feedback.dist_to_goal.header.seq, _x.action_feedback.feedback.dist_to_goal.header.stamp.secs, _x.action_feedback.feedback.dist_to_goal.header.stamp.nsecs))
      _x = self.action_feedback.feedback.dist_to_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10dB().pack(_x.action_feedback.feedback.dist_to_goal.pose.position.x, _x.action_feedback.feedback.dist_to_goal.pose.position.y, _x.action_feedback.feedback.dist_to_goal.pose.position.z, _x.action_feedback.feedback.dist_to_goal.pose.orientation.x, _x.action_feedback.feedback.dist_to_goal.pose.orientation.y, _x.action_feedback.feedback.dist_to_goal.pose.orientation.z, _x.action_feedback.feedback.dist_to_goal.pose.orientation.w, _x.action_feedback.feedback.pose.x, _x.action_feedback.feedback.pose.y, _x.action_feedback.feedback.pose.theta, _x.action_feedback.feedback.marker_inversion))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.action_goal is None:
        self.action_goal = mir_actions.msg.MirMoveBaseActionGoal()
      if self.action_result is None:
        self.action_result = mir_actions.msg.MirMoveBaseActionResult()
      if self.action_feedback is None:
        self.action_feedback = mir_actions.msg.MirMoveBaseActionFeedback()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.action_goal.header.seq, _x.action_goal.header.stamp.secs, _x.action_goal.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal_id.stamp.secs, _x.action_goal.goal_id.stamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal_id.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_goal.goal_id.id = str[start:end]
      _x = self
      start = end
      end += 14
      (_x.action_goal.goal.move_task, _x.action_goal.goal.target_pose.header.seq, _x.action_goal.goal.target_pose.header.stamp.secs, _x.action_goal.goal.target_pose.header.stamp.nsecs,) = _get_struct_h3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_goal.goal.target_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.action_goal.goal.target_pose.pose.position.x, _x.action_goal.goal.target_pose.pose.position.y, _x.action_goal.goal.target_pose.pose.position.z, _x.action_goal.goal.target_pose.pose.orientation.x, _x.action_goal.goal.target_pose.pose.orientation.y, _x.action_goal.goal.target_pose.pose.orientation.z, _x.action_goal.goal.target_pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target_guid = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_goal.goal.target_guid = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.action_goal.goal.goal_dist_threshold, _x.action_goal.goal.goal_orientation_threshold, _x.action_goal.goal.path.header.seq, _x.action_goal.goal.path.header.stamp.secs, _x.action_goal.goal.path.header.stamp.nsecs,) = _get_struct_2d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.path.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_goal.goal.path.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.path.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.PoseStamped()
        _v16 = val1.header
        start = end
        end += 4
        (_v16.seq,) = _get_struct_I().unpack(str[start:end])
        _v17 = _v16.stamp
        _x = _v17
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v16.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v16.frame_id = str[start:end]
        _v18 = val1.pose
        _v19 = _v18.position
        _x = _v19
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v20 = _v18.orientation
        _x = _v20
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.action_goal.goal.path.poses.append(val1)
      _x = self
      start = end
      end += 76
      (_x.action_goal.goal.max_plan_time, _x.action_goal.goal.clear_costmaps, _x.action_goal.goal.pause_command, _x.action_goal.goal.continue_command, _x.action_goal.goal.yaw, _x.action_goal.goal.collision_detection, _x.action_goal.goal.collision_avoidance, _x.action_goal.goal.disable_collision_check_dist, _x.action_goal.goal.max_linear_speed, _x.action_goal.goal.max_rotational_speed, _x.action_goal.goal.pid_dist_offset, _x.action_goal.goal.target_offset, _x.action_goal.goal.only_collision_detection, _x.action_goal.goal.timeout, _x.action_goal.goal.pattern_type, _x.action_goal.goal.pattern_value, _x.action_goal.goal.only_track, _x.action_goal.goal.same_goal,) = _get_struct_f3Bd2B5dBd2i2B().unpack(str[start:end])
      self.action_goal.goal.clear_costmaps = bool(self.action_goal.goal.clear_costmaps)
      self.action_goal.goal.pause_command = bool(self.action_goal.goal.pause_command)
      self.action_goal.goal.continue_command = bool(self.action_goal.goal.continue_command)
      self.action_goal.goal.collision_detection = bool(self.action_goal.goal.collision_detection)
      self.action_goal.goal.collision_avoidance = bool(self.action_goal.goal.collision_avoidance)
      self.action_goal.goal.only_collision_detection = bool(self.action_goal.goal.only_collision_detection)
      self.action_goal.goal.only_track = bool(self.action_goal.goal.only_track)
      self.action_goal.goal.same_goal = bool(self.action_goal.goal.same_goal)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.pose_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_goal.goal.pose_frame = str[start:end]
      _x = self
      start = end
      end += 93
      (_x.action_goal.goal.pose.x, _x.action_goal.goal.pose.y, _x.action_goal.goal.pose.theta, _x.action_goal.goal.offset.x, _x.action_goal.goal.offset.y, _x.action_goal.goal.offset.theta, _x.action_goal.goal.bar_length, _x.action_goal.goal.bar_distance, _x.action_goal.goal.shelf_leg_asymmetry_x, _x.action_goal.goal.tolerance, _x.action_goal.goal.path_type.path_type, _x.action_goal.goal.start_pose.header.seq, _x.action_goal.goal.start_pose.header.stamp.secs, _x.action_goal.goal.start_pose.header.stamp.nsecs,) = _get_struct_10dB3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.start_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_goal.goal.start_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.action_goal.goal.start_pose.pose.position.x, _x.action_goal.goal.start_pose.pose.position.y, _x.action_goal.goal.start_pose.pose.position.z, _x.action_goal.goal.start_pose.pose.orientation.x, _x.action_goal.goal.start_pose.pose.orientation.y, _x.action_goal.goal.start_pose.pose.orientation.z, _x.action_goal.goal.start_pose.pose.orientation.w, _x.action_result.header.seq, _x.action_result.header.stamp.secs, _x.action_result.header.stamp.nsecs,) = _get_struct_7d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_result.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_result.status.goal_id.stamp.secs, _x.action_result.status.goal_id.stamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.status.goal_id.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_result.status.goal_id.id = str[start:end]
      start = end
      end += 1
      (self.action_result.status.status,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.status.text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_result.status.text = str[start:end]
      _x = self
      start = end
      end += 14
      (_x.action_result.result.end_state, _x.action_result.result.end_pose.header.seq, _x.action_result.result.end_pose.header.stamp.secs, _x.action_result.result.end_pose.header.stamp.nsecs,) = _get_struct_h3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.result.end_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_result.result.end_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.action_result.result.end_pose.pose.position.x, _x.action_result.result.end_pose.pose.position.y, _x.action_result.result.end_pose.pose.position.z, _x.action_result.result.end_pose.pose.orientation.x, _x.action_result.result.end_pose.pose.orientation.y, _x.action_result.result.end_pose.pose.orientation.z, _x.action_result.result.end_pose.pose.orientation.w, _x.action_result.result.pose.x, _x.action_result.result.pose.y, _x.action_result.result.pose.theta,) = _get_struct_10d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.result.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_result.result.message = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.action_feedback.header.seq, _x.action_feedback.header.stamp.secs, _x.action_feedback.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_feedback.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_feedback.status.goal_id.stamp.secs, _x.action_feedback.status.goal_id.stamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.status.goal_id.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_feedback.status.goal_id.id = str[start:end]
      start = end
      end += 1
      (self.action_feedback.status.status,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.status.text = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_feedback.status.text = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.action_feedback.feedback.state, _x.action_feedback.feedback.base_position.header.seq, _x.action_feedback.feedback.base_position.header.stamp.secs, _x.action_feedback.feedback.base_position.header.stamp.nsecs,) = _get_struct_b3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.feedback.base_position.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_feedback.feedback.base_position.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.action_feedback.feedback.base_position.pose.position.x, _x.action_feedback.feedback.base_position.pose.position.y, _x.action_feedback.feedback.base_position.pose.position.z, _x.action_feedback.feedback.base_position.pose.orientation.x, _x.action_feedback.feedback.base_position.pose.orientation.y, _x.action_feedback.feedback.base_position.pose.orientation.z, _x.action_feedback.feedback.base_position.pose.orientation.w, _x.action_feedback.feedback.current_goal.header.seq, _x.action_feedback.feedback.current_goal.header.stamp.secs, _x.action_feedback.feedback.current_goal.header.stamp.nsecs,) = _get_struct_7d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.feedback.current_goal.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_feedback.feedback.current_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.action_feedback.feedback.current_goal.pose.position.x, _x.action_feedback.feedback.current_goal.pose.position.y, _x.action_feedback.feedback.current_goal.pose.position.z, _x.action_feedback.feedback.current_goal.pose.orientation.x, _x.action_feedback.feedback.current_goal.pose.orientation.y, _x.action_feedback.feedback.current_goal.pose.orientation.z, _x.action_feedback.feedback.current_goal.pose.orientation.w, _x.action_feedback.feedback.dist_to_goal.header.seq, _x.action_feedback.feedback.dist_to_goal.header.stamp.secs, _x.action_feedback.feedback.dist_to_goal.header.stamp.nsecs,) = _get_struct_7d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.feedback.dist_to_goal.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_feedback.feedback.dist_to_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 81
      (_x.action_feedback.feedback.dist_to_goal.pose.position.x, _x.action_feedback.feedback.dist_to_goal.pose.position.y, _x.action_feedback.feedback.dist_to_goal.pose.position.z, _x.action_feedback.feedback.dist_to_goal.pose.orientation.x, _x.action_feedback.feedback.dist_to_goal.pose.orientation.y, _x.action_feedback.feedback.dist_to_goal.pose.orientation.z, _x.action_feedback.feedback.dist_to_goal.pose.orientation.w, _x.action_feedback.feedback.pose.x, _x.action_feedback.feedback.pose.y, _x.action_feedback.feedback.pose.theta, _x.action_feedback.feedback.marker_inversion,) = _get_struct_10dB().unpack(str[start:end])
      self.action_feedback.feedback.marker_inversion = bool(self.action_feedback.feedback.marker_inversion)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_10d = None
def _get_struct_10d():
    global _struct_10d
    if _struct_10d is None:
        _struct_10d = struct.Struct("<10d")
    return _struct_10d
_struct_10dB = None
def _get_struct_10dB():
    global _struct_10dB
    if _struct_10dB is None:
        _struct_10dB = struct.Struct("<10dB")
    return _struct_10dB
_struct_10dB3I = None
def _get_struct_10dB3I():
    global _struct_10dB3I
    if _struct_10dB3I is None:
        _struct_10dB3I = struct.Struct("<10dB3I")
    return _struct_10dB3I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_2d3I = None
def _get_struct_2d3I():
    global _struct_2d3I
    if _struct_2d3I is None:
        _struct_2d3I = struct.Struct("<2d3I")
    return _struct_2d3I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_7d = None
def _get_struct_7d():
    global _struct_7d
    if _struct_7d is None:
        _struct_7d = struct.Struct("<7d")
    return _struct_7d
_struct_7d3I = None
def _get_struct_7d3I():
    global _struct_7d3I
    if _struct_7d3I is None:
        _struct_7d3I = struct.Struct("<7d3I")
    return _struct_7d3I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_b3I = None
def _get_struct_b3I():
    global _struct_b3I
    if _struct_b3I is None:
        _struct_b3I = struct.Struct("<b3I")
    return _struct_b3I
_struct_f3Bd2B5dBd2i2B = None
def _get_struct_f3Bd2B5dBd2i2B():
    global _struct_f3Bd2B5dBd2i2B
    if _struct_f3Bd2B5dBd2i2B is None:
        _struct_f3Bd2B5dBd2i2B = struct.Struct("<f3Bd2B5dBd2i2B")
    return _struct_f3Bd2B5dBd2i2B
_struct_h3I = None
def _get_struct_h3I():
    global _struct_h3I
    if _struct_h3I is None:
        _struct_h3I = struct.Struct("<h3I")
    return _struct_h3I
