# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from mir_actions/MirMoveBaseFeedback.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class MirMoveBaseFeedback(genpy.Message):
  _md5sum = "91889a1bfc370b351d55faacdff14e74"
  _type = "mir_actions/MirMoveBaseFeedback"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
#feedback
#shared
int8 NOT_READY = -1
int8 UNKNOWN = -2
int8 WAITING_FOR_FLEET = -3
int8 COLLISION = -4

#global move states
int8 PLANNING = 0
int8 CONTROLLING = 1
int8 CLEARING = 2

#relative move states
int8 DOCKING = 3

#shared feedback
int8 state

#global move feedback
geometry_msgs/PoseStamped base_position

#relative move feedback
geometry_msgs/PoseStamped current_goal
geometry_msgs/PoseStamped dist_to_goal

#docking move feedback
geometry_msgs/Pose2D pose
bool marker_inversion

#path_types
    #reverse_trolly
int8 MOVING_FORWARD = 10
int8 MOVING_BACKWARD = 11


================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Pose2D
# Deprecated
# Please use the full 3D pose.

# In general our recommendation is to use a full 3D representation of everything and for 2D specific applications make the appropriate projections into the plane for their calculations but optimally will preserve the 3D information during processing.

# If we have parallel copies of 2D datatypes every UI and other pipeline will end up needing to have dual interfaces to plot everything. And you will end up with not being able to use 3D tools for 2D use cases even if they're completely valid, as you'd have to reimplement it with different inputs and outputs. It's not particularly hard to plot the 2D pose or compute the yaw error for the Pose message and there are already tools and libraries that can do this for you.


# This expresses a position and orientation on a 2D manifold.

float64 x
float64 y
float64 theta
"""
  # Pseudo-constants
  NOT_READY = -1
  UNKNOWN = -2
  WAITING_FOR_FLEET = -3
  COLLISION = -4
  PLANNING = 0
  CONTROLLING = 1
  CLEARING = 2
  DOCKING = 3
  MOVING_FORWARD = 10
  MOVING_BACKWARD = 11

  __slots__ = ['state','base_position','current_goal','dist_to_goal','pose','marker_inversion']
  _slot_types = ['int8','geometry_msgs/PoseStamped','geometry_msgs/PoseStamped','geometry_msgs/PoseStamped','geometry_msgs/Pose2D','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       state,base_position,current_goal,dist_to_goal,pose,marker_inversion

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MirMoveBaseFeedback, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.state is None:
        self.state = 0
      if self.base_position is None:
        self.base_position = geometry_msgs.msg.PoseStamped()
      if self.current_goal is None:
        self.current_goal = geometry_msgs.msg.PoseStamped()
      if self.dist_to_goal is None:
        self.dist_to_goal = geometry_msgs.msg.PoseStamped()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose2D()
      if self.marker_inversion is None:
        self.marker_inversion = False
    else:
      self.state = 0
      self.base_position = geometry_msgs.msg.PoseStamped()
      self.current_goal = geometry_msgs.msg.PoseStamped()
      self.dist_to_goal = geometry_msgs.msg.PoseStamped()
      self.pose = geometry_msgs.msg.Pose2D()
      self.marker_inversion = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_b3I().pack(_x.state, _x.base_position.header.seq, _x.base_position.header.stamp.secs, _x.base_position.header.stamp.nsecs))
      _x = self.base_position.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d3I().pack(_x.base_position.pose.position.x, _x.base_position.pose.position.y, _x.base_position.pose.position.z, _x.base_position.pose.orientation.x, _x.base_position.pose.orientation.y, _x.base_position.pose.orientation.z, _x.base_position.pose.orientation.w, _x.current_goal.header.seq, _x.current_goal.header.stamp.secs, _x.current_goal.header.stamp.nsecs))
      _x = self.current_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d3I().pack(_x.current_goal.pose.position.x, _x.current_goal.pose.position.y, _x.current_goal.pose.position.z, _x.current_goal.pose.orientation.x, _x.current_goal.pose.orientation.y, _x.current_goal.pose.orientation.z, _x.current_goal.pose.orientation.w, _x.dist_to_goal.header.seq, _x.dist_to_goal.header.stamp.secs, _x.dist_to_goal.header.stamp.nsecs))
      _x = self.dist_to_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10dB().pack(_x.dist_to_goal.pose.position.x, _x.dist_to_goal.pose.position.y, _x.dist_to_goal.pose.position.z, _x.dist_to_goal.pose.orientation.x, _x.dist_to_goal.pose.orientation.y, _x.dist_to_goal.pose.orientation.z, _x.dist_to_goal.pose.orientation.w, _x.pose.x, _x.pose.y, _x.pose.theta, _x.marker_inversion))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.base_position is None:
        self.base_position = geometry_msgs.msg.PoseStamped()
      if self.current_goal is None:
        self.current_goal = geometry_msgs.msg.PoseStamped()
      if self.dist_to_goal is None:
        self.dist_to_goal = geometry_msgs.msg.PoseStamped()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose2D()
      end = 0
      _x = self
      start = end
      end += 13
      (_x.state, _x.base_position.header.seq, _x.base_position.header.stamp.secs, _x.base_position.header.stamp.nsecs,) = _get_struct_b3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.base_position.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.base_position.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.base_position.pose.position.x, _x.base_position.pose.position.y, _x.base_position.pose.position.z, _x.base_position.pose.orientation.x, _x.base_position.pose.orientation.y, _x.base_position.pose.orientation.z, _x.base_position.pose.orientation.w, _x.current_goal.header.seq, _x.current_goal.header.stamp.secs, _x.current_goal.header.stamp.nsecs,) = _get_struct_7d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.current_goal.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.current_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.current_goal.pose.position.x, _x.current_goal.pose.position.y, _x.current_goal.pose.position.z, _x.current_goal.pose.orientation.x, _x.current_goal.pose.orientation.y, _x.current_goal.pose.orientation.z, _x.current_goal.pose.orientation.w, _x.dist_to_goal.header.seq, _x.dist_to_goal.header.stamp.secs, _x.dist_to_goal.header.stamp.nsecs,) = _get_struct_7d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.dist_to_goal.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.dist_to_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 81
      (_x.dist_to_goal.pose.position.x, _x.dist_to_goal.pose.position.y, _x.dist_to_goal.pose.position.z, _x.dist_to_goal.pose.orientation.x, _x.dist_to_goal.pose.orientation.y, _x.dist_to_goal.pose.orientation.z, _x.dist_to_goal.pose.orientation.w, _x.pose.x, _x.pose.y, _x.pose.theta, _x.marker_inversion,) = _get_struct_10dB().unpack(str[start:end])
      self.marker_inversion = bool(self.marker_inversion)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_b3I().pack(_x.state, _x.base_position.header.seq, _x.base_position.header.stamp.secs, _x.base_position.header.stamp.nsecs))
      _x = self.base_position.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d3I().pack(_x.base_position.pose.position.x, _x.base_position.pose.position.y, _x.base_position.pose.position.z, _x.base_position.pose.orientation.x, _x.base_position.pose.orientation.y, _x.base_position.pose.orientation.z, _x.base_position.pose.orientation.w, _x.current_goal.header.seq, _x.current_goal.header.stamp.secs, _x.current_goal.header.stamp.nsecs))
      _x = self.current_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d3I().pack(_x.current_goal.pose.position.x, _x.current_goal.pose.position.y, _x.current_goal.pose.position.z, _x.current_goal.pose.orientation.x, _x.current_goal.pose.orientation.y, _x.current_goal.pose.orientation.z, _x.current_goal.pose.orientation.w, _x.dist_to_goal.header.seq, _x.dist_to_goal.header.stamp.secs, _x.dist_to_goal.header.stamp.nsecs))
      _x = self.dist_to_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10dB().pack(_x.dist_to_goal.pose.position.x, _x.dist_to_goal.pose.position.y, _x.dist_to_goal.pose.position.z, _x.dist_to_goal.pose.orientation.x, _x.dist_to_goal.pose.orientation.y, _x.dist_to_goal.pose.orientation.z, _x.dist_to_goal.pose.orientation.w, _x.pose.x, _x.pose.y, _x.pose.theta, _x.marker_inversion))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.base_position is None:
        self.base_position = geometry_msgs.msg.PoseStamped()
      if self.current_goal is None:
        self.current_goal = geometry_msgs.msg.PoseStamped()
      if self.dist_to_goal is None:
        self.dist_to_goal = geometry_msgs.msg.PoseStamped()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose2D()
      end = 0
      _x = self
      start = end
      end += 13
      (_x.state, _x.base_position.header.seq, _x.base_position.header.stamp.secs, _x.base_position.header.stamp.nsecs,) = _get_struct_b3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.base_position.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.base_position.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.base_position.pose.position.x, _x.base_position.pose.position.y, _x.base_position.pose.position.z, _x.base_position.pose.orientation.x, _x.base_position.pose.orientation.y, _x.base_position.pose.orientation.z, _x.base_position.pose.orientation.w, _x.current_goal.header.seq, _x.current_goal.header.stamp.secs, _x.current_goal.header.stamp.nsecs,) = _get_struct_7d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.current_goal.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.current_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.current_goal.pose.position.x, _x.current_goal.pose.position.y, _x.current_goal.pose.position.z, _x.current_goal.pose.orientation.x, _x.current_goal.pose.orientation.y, _x.current_goal.pose.orientation.z, _x.current_goal.pose.orientation.w, _x.dist_to_goal.header.seq, _x.dist_to_goal.header.stamp.secs, _x.dist_to_goal.header.stamp.nsecs,) = _get_struct_7d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.dist_to_goal.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.dist_to_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 81
      (_x.dist_to_goal.pose.position.x, _x.dist_to_goal.pose.position.y, _x.dist_to_goal.pose.position.z, _x.dist_to_goal.pose.orientation.x, _x.dist_to_goal.pose.orientation.y, _x.dist_to_goal.pose.orientation.z, _x.dist_to_goal.pose.orientation.w, _x.pose.x, _x.pose.y, _x.pose.theta, _x.marker_inversion,) = _get_struct_10dB().unpack(str[start:end])
      self.marker_inversion = bool(self.marker_inversion)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_10dB = None
def _get_struct_10dB():
    global _struct_10dB
    if _struct_10dB is None:
        _struct_10dB = struct.Struct("<10dB")
    return _struct_10dB
_struct_7d3I = None
def _get_struct_7d3I():
    global _struct_7d3I
    if _struct_7d3I is None:
        _struct_7d3I = struct.Struct("<7d3I")
    return _struct_7d3I
_struct_b3I = None
def _get_struct_b3I():
    global _struct_b3I
    if _struct_b3I is None:
        _struct_b3I = struct.Struct("<b3I")
    return _struct_b3I
