# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from mir_actions/MirMoveBaseGoal.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import mir_msgs.msg
import nav_msgs.msg
import std_msgs.msg

class MirMoveBaseGoal(genpy.Message):
  _md5sum = "7343be65bba09aaabf1de2ee776454f8"
  _type = "mir_actions/MirMoveBaseGoal"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
#goal definition
#move type
int16 BASE_MOVE = 0
int16 GLOBAL_MOVE = 1
int16 RELATIVE_MOVE = 2
int16 RELATIVE_MARKER_MOVE = 3
int16 DOCKING_MOVE = 4
int16 DOCKING_GLOBAL_MOVE = 5
int16 PATH_TYPE = 6
int16 move_task

#shared parameters
geometry_msgs/PoseStamped target_pose
string target_guid

#global move parameters
float64 goal_dist_threshold
float64 goal_orientation_threshold
nav_msgs/Path path
float32 max_plan_time
bool clear_costmaps
bool pause_command
bool continue_command

#relative move parameters
float64 yaw
bool collision_detection
bool collision_avoidance
float64 disable_collision_check_dist
float64 max_linear_speed
float64 max_rotational_speed
float64 pid_dist_offset
float64 target_offset
bool only_collision_detection
float64 timeout

#docking move parameters
int32 pattern_type
int32 pattern_value
bool only_track
bool same_goal
string pose_frame
geometry_msgs/Pose2D pose
geometry_msgs/Pose2D offset
float64 bar_length
float64 bar_distance
float64 shelf_leg_asymmetry_x
float64 tolerance

#Path type
mir_msgs/MirLocalPlannerPathTypes path_type
geometry_msgs/PoseStamped start_pose
# float64 timeout



================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: nav_msgs/Path
#An array of poses that represents a Path for a robot to follow
Header header
geometry_msgs/PoseStamped[] poses

================================================================================
MSG: geometry_msgs/Pose2D
# Deprecated
# Please use the full 3D pose.

# In general our recommendation is to use a full 3D representation of everything and for 2D specific applications make the appropriate projections into the plane for their calculations but optimally will preserve the 3D information during processing.

# If we have parallel copies of 2D datatypes every UI and other pipeline will end up needing to have dual interfaces to plot everything. And you will end up with not being able to use 3D tools for 2D use cases even if they're completely valid, as you'd have to reimplement it with different inputs and outputs. It's not particularly hard to plot the 2D pose or compute the yaw error for the Pose message and there are already tools and libraries that can do this for you.


# This expresses a position and orientation on a 2D manifold.

float64 x
float64 y
float64 theta

================================================================================
MSG: mir_msgs/MirLocalPlannerPathTypes
uint8 REVERSE_TROLLEY_STANDARD=1
uint8 REVERSE_TROLLEY_FAST=2
uint8 REVERSE_TROLLEY_COMPACT=3


uint8 path_type
"""
  # Pseudo-constants
  BASE_MOVE = 0
  GLOBAL_MOVE = 1
  RELATIVE_MOVE = 2
  RELATIVE_MARKER_MOVE = 3
  DOCKING_MOVE = 4
  DOCKING_GLOBAL_MOVE = 5
  PATH_TYPE = 6

  __slots__ = ['move_task','target_pose','target_guid','goal_dist_threshold','goal_orientation_threshold','path','max_plan_time','clear_costmaps','pause_command','continue_command','yaw','collision_detection','collision_avoidance','disable_collision_check_dist','max_linear_speed','max_rotational_speed','pid_dist_offset','target_offset','only_collision_detection','timeout','pattern_type','pattern_value','only_track','same_goal','pose_frame','pose','offset','bar_length','bar_distance','shelf_leg_asymmetry_x','tolerance','path_type','start_pose']
  _slot_types = ['int16','geometry_msgs/PoseStamped','string','float64','float64','nav_msgs/Path','float32','bool','bool','bool','float64','bool','bool','float64','float64','float64','float64','float64','bool','float64','int32','int32','bool','bool','string','geometry_msgs/Pose2D','geometry_msgs/Pose2D','float64','float64','float64','float64','mir_msgs/MirLocalPlannerPathTypes','geometry_msgs/PoseStamped']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       move_task,target_pose,target_guid,goal_dist_threshold,goal_orientation_threshold,path,max_plan_time,clear_costmaps,pause_command,continue_command,yaw,collision_detection,collision_avoidance,disable_collision_check_dist,max_linear_speed,max_rotational_speed,pid_dist_offset,target_offset,only_collision_detection,timeout,pattern_type,pattern_value,only_track,same_goal,pose_frame,pose,offset,bar_length,bar_distance,shelf_leg_asymmetry_x,tolerance,path_type,start_pose

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MirMoveBaseGoal, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.move_task is None:
        self.move_task = 0
      if self.target_pose is None:
        self.target_pose = geometry_msgs.msg.PoseStamped()
      if self.target_guid is None:
        self.target_guid = ''
      if self.goal_dist_threshold is None:
        self.goal_dist_threshold = 0.
      if self.goal_orientation_threshold is None:
        self.goal_orientation_threshold = 0.
      if self.path is None:
        self.path = nav_msgs.msg.Path()
      if self.max_plan_time is None:
        self.max_plan_time = 0.
      if self.clear_costmaps is None:
        self.clear_costmaps = False
      if self.pause_command is None:
        self.pause_command = False
      if self.continue_command is None:
        self.continue_command = False
      if self.yaw is None:
        self.yaw = 0.
      if self.collision_detection is None:
        self.collision_detection = False
      if self.collision_avoidance is None:
        self.collision_avoidance = False
      if self.disable_collision_check_dist is None:
        self.disable_collision_check_dist = 0.
      if self.max_linear_speed is None:
        self.max_linear_speed = 0.
      if self.max_rotational_speed is None:
        self.max_rotational_speed = 0.
      if self.pid_dist_offset is None:
        self.pid_dist_offset = 0.
      if self.target_offset is None:
        self.target_offset = 0.
      if self.only_collision_detection is None:
        self.only_collision_detection = False
      if self.timeout is None:
        self.timeout = 0.
      if self.pattern_type is None:
        self.pattern_type = 0
      if self.pattern_value is None:
        self.pattern_value = 0
      if self.only_track is None:
        self.only_track = False
      if self.same_goal is None:
        self.same_goal = False
      if self.pose_frame is None:
        self.pose_frame = ''
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose2D()
      if self.offset is None:
        self.offset = geometry_msgs.msg.Pose2D()
      if self.bar_length is None:
        self.bar_length = 0.
      if self.bar_distance is None:
        self.bar_distance = 0.
      if self.shelf_leg_asymmetry_x is None:
        self.shelf_leg_asymmetry_x = 0.
      if self.tolerance is None:
        self.tolerance = 0.
      if self.path_type is None:
        self.path_type = mir_msgs.msg.MirLocalPlannerPathTypes()
      if self.start_pose is None:
        self.start_pose = geometry_msgs.msg.PoseStamped()
    else:
      self.move_task = 0
      self.target_pose = geometry_msgs.msg.PoseStamped()
      self.target_guid = ''
      self.goal_dist_threshold = 0.
      self.goal_orientation_threshold = 0.
      self.path = nav_msgs.msg.Path()
      self.max_plan_time = 0.
      self.clear_costmaps = False
      self.pause_command = False
      self.continue_command = False
      self.yaw = 0.
      self.collision_detection = False
      self.collision_avoidance = False
      self.disable_collision_check_dist = 0.
      self.max_linear_speed = 0.
      self.max_rotational_speed = 0.
      self.pid_dist_offset = 0.
      self.target_offset = 0.
      self.only_collision_detection = False
      self.timeout = 0.
      self.pattern_type = 0
      self.pattern_value = 0
      self.only_track = False
      self.same_goal = False
      self.pose_frame = ''
      self.pose = geometry_msgs.msg.Pose2D()
      self.offset = geometry_msgs.msg.Pose2D()
      self.bar_length = 0.
      self.bar_distance = 0.
      self.shelf_leg_asymmetry_x = 0.
      self.tolerance = 0.
      self.path_type = mir_msgs.msg.MirLocalPlannerPathTypes()
      self.start_pose = geometry_msgs.msg.PoseStamped()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_h3I().pack(_x.move_task, _x.target_pose.header.seq, _x.target_pose.header.stamp.secs, _x.target_pose.header.stamp.nsecs))
      _x = self.target_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.target_pose.pose.position.x, _x.target_pose.pose.position.y, _x.target_pose.pose.position.z, _x.target_pose.pose.orientation.x, _x.target_pose.pose.orientation.y, _x.target_pose.pose.orientation.z, _x.target_pose.pose.orientation.w))
      _x = self.target_guid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2d3I().pack(_x.goal_dist_threshold, _x.goal_orientation_threshold, _x.path.header.seq, _x.path.header.stamp.secs, _x.path.header.stamp.nsecs))
      _x = self.path.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.path.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.path.poses:
        _v1 = val1.header
        _x = _v1.seq
        buff.write(_get_struct_I().pack(_x))
        _v2 = _v1.stamp
        _x = _v2
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v1.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v3 = val1.pose
        _v4 = _v3.position
        _x = _v4
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v5 = _v3.orientation
        _x = _v5
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_get_struct_f3Bd2B5dBd2i2B().pack(_x.max_plan_time, _x.clear_costmaps, _x.pause_command, _x.continue_command, _x.yaw, _x.collision_detection, _x.collision_avoidance, _x.disable_collision_check_dist, _x.max_linear_speed, _x.max_rotational_speed, _x.pid_dist_offset, _x.target_offset, _x.only_collision_detection, _x.timeout, _x.pattern_type, _x.pattern_value, _x.only_track, _x.same_goal))
      _x = self.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10dB3I().pack(_x.pose.x, _x.pose.y, _x.pose.theta, _x.offset.x, _x.offset.y, _x.offset.theta, _x.bar_length, _x.bar_distance, _x.shelf_leg_asymmetry_x, _x.tolerance, _x.path_type.path_type, _x.start_pose.header.seq, _x.start_pose.header.stamp.secs, _x.start_pose.header.stamp.nsecs))
      _x = self.start_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.start_pose.pose.position.x, _x.start_pose.pose.position.y, _x.start_pose.pose.position.z, _x.start_pose.pose.orientation.x, _x.start_pose.pose.orientation.y, _x.start_pose.pose.orientation.z, _x.start_pose.pose.orientation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.target_pose is None:
        self.target_pose = geometry_msgs.msg.PoseStamped()
      if self.path is None:
        self.path = nav_msgs.msg.Path()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose2D()
      if self.offset is None:
        self.offset = geometry_msgs.msg.Pose2D()
      if self.path_type is None:
        self.path_type = mir_msgs.msg.MirLocalPlannerPathTypes()
      if self.start_pose is None:
        self.start_pose = geometry_msgs.msg.PoseStamped()
      end = 0
      _x = self
      start = end
      end += 14
      (_x.move_task, _x.target_pose.header.seq, _x.target_pose.header.stamp.secs, _x.target_pose.header.stamp.nsecs,) = _get_struct_h3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.target_pose.pose.position.x, _x.target_pose.pose.position.y, _x.target_pose.pose.position.z, _x.target_pose.pose.orientation.x, _x.target_pose.pose.orientation.y, _x.target_pose.pose.orientation.z, _x.target_pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_guid = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_guid = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.goal_dist_threshold, _x.goal_orientation_threshold, _x.path.header.seq, _x.path.header.stamp.secs, _x.path.header.stamp.nsecs,) = _get_struct_2d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.path.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.path.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.path.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.PoseStamped()
        _v6 = val1.header
        start = end
        end += 4
        (_v6.seq,) = _get_struct_I().unpack(str[start:end])
        _v7 = _v6.stamp
        _x = _v7
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v6.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v6.frame_id = str[start:end]
        _v8 = val1.pose
        _v9 = _v8.position
        _x = _v9
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v10 = _v8.orientation
        _x = _v10
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.path.poses.append(val1)
      _x = self
      start = end
      end += 76
      (_x.max_plan_time, _x.clear_costmaps, _x.pause_command, _x.continue_command, _x.yaw, _x.collision_detection, _x.collision_avoidance, _x.disable_collision_check_dist, _x.max_linear_speed, _x.max_rotational_speed, _x.pid_dist_offset, _x.target_offset, _x.only_collision_detection, _x.timeout, _x.pattern_type, _x.pattern_value, _x.only_track, _x.same_goal,) = _get_struct_f3Bd2B5dBd2i2B().unpack(str[start:end])
      self.clear_costmaps = bool(self.clear_costmaps)
      self.pause_command = bool(self.pause_command)
      self.continue_command = bool(self.continue_command)
      self.collision_detection = bool(self.collision_detection)
      self.collision_avoidance = bool(self.collision_avoidance)
      self.only_collision_detection = bool(self.only_collision_detection)
      self.only_track = bool(self.only_track)
      self.same_goal = bool(self.same_goal)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose_frame = str[start:end]
      _x = self
      start = end
      end += 93
      (_x.pose.x, _x.pose.y, _x.pose.theta, _x.offset.x, _x.offset.y, _x.offset.theta, _x.bar_length, _x.bar_distance, _x.shelf_leg_asymmetry_x, _x.tolerance, _x.path_type.path_type, _x.start_pose.header.seq, _x.start_pose.header.stamp.secs, _x.start_pose.header.stamp.nsecs,) = _get_struct_10dB3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.start_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.start_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.start_pose.pose.position.x, _x.start_pose.pose.position.y, _x.start_pose.pose.position.z, _x.start_pose.pose.orientation.x, _x.start_pose.pose.orientation.y, _x.start_pose.pose.orientation.z, _x.start_pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_h3I().pack(_x.move_task, _x.target_pose.header.seq, _x.target_pose.header.stamp.secs, _x.target_pose.header.stamp.nsecs))
      _x = self.target_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.target_pose.pose.position.x, _x.target_pose.pose.position.y, _x.target_pose.pose.position.z, _x.target_pose.pose.orientation.x, _x.target_pose.pose.orientation.y, _x.target_pose.pose.orientation.z, _x.target_pose.pose.orientation.w))
      _x = self.target_guid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2d3I().pack(_x.goal_dist_threshold, _x.goal_orientation_threshold, _x.path.header.seq, _x.path.header.stamp.secs, _x.path.header.stamp.nsecs))
      _x = self.path.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.path.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.path.poses:
        _v11 = val1.header
        _x = _v11.seq
        buff.write(_get_struct_I().pack(_x))
        _v12 = _v11.stamp
        _x = _v12
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v11.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v13 = val1.pose
        _v14 = _v13.position
        _x = _v14
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v15 = _v13.orientation
        _x = _v15
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_get_struct_f3Bd2B5dBd2i2B().pack(_x.max_plan_time, _x.clear_costmaps, _x.pause_command, _x.continue_command, _x.yaw, _x.collision_detection, _x.collision_avoidance, _x.disable_collision_check_dist, _x.max_linear_speed, _x.max_rotational_speed, _x.pid_dist_offset, _x.target_offset, _x.only_collision_detection, _x.timeout, _x.pattern_type, _x.pattern_value, _x.only_track, _x.same_goal))
      _x = self.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10dB3I().pack(_x.pose.x, _x.pose.y, _x.pose.theta, _x.offset.x, _x.offset.y, _x.offset.theta, _x.bar_length, _x.bar_distance, _x.shelf_leg_asymmetry_x, _x.tolerance, _x.path_type.path_type, _x.start_pose.header.seq, _x.start_pose.header.stamp.secs, _x.start_pose.header.stamp.nsecs))
      _x = self.start_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.start_pose.pose.position.x, _x.start_pose.pose.position.y, _x.start_pose.pose.position.z, _x.start_pose.pose.orientation.x, _x.start_pose.pose.orientation.y, _x.start_pose.pose.orientation.z, _x.start_pose.pose.orientation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.target_pose is None:
        self.target_pose = geometry_msgs.msg.PoseStamped()
      if self.path is None:
        self.path = nav_msgs.msg.Path()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose2D()
      if self.offset is None:
        self.offset = geometry_msgs.msg.Pose2D()
      if self.path_type is None:
        self.path_type = mir_msgs.msg.MirLocalPlannerPathTypes()
      if self.start_pose is None:
        self.start_pose = geometry_msgs.msg.PoseStamped()
      end = 0
      _x = self
      start = end
      end += 14
      (_x.move_task, _x.target_pose.header.seq, _x.target_pose.header.stamp.secs, _x.target_pose.header.stamp.nsecs,) = _get_struct_h3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.target_pose.pose.position.x, _x.target_pose.pose.position.y, _x.target_pose.pose.position.z, _x.target_pose.pose.orientation.x, _x.target_pose.pose.orientation.y, _x.target_pose.pose.orientation.z, _x.target_pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_guid = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_guid = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.goal_dist_threshold, _x.goal_orientation_threshold, _x.path.header.seq, _x.path.header.stamp.secs, _x.path.header.stamp.nsecs,) = _get_struct_2d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.path.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.path.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.path.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.PoseStamped()
        _v16 = val1.header
        start = end
        end += 4
        (_v16.seq,) = _get_struct_I().unpack(str[start:end])
        _v17 = _v16.stamp
        _x = _v17
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v16.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v16.frame_id = str[start:end]
        _v18 = val1.pose
        _v19 = _v18.position
        _x = _v19
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v20 = _v18.orientation
        _x = _v20
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.path.poses.append(val1)
      _x = self
      start = end
      end += 76
      (_x.max_plan_time, _x.clear_costmaps, _x.pause_command, _x.continue_command, _x.yaw, _x.collision_detection, _x.collision_avoidance, _x.disable_collision_check_dist, _x.max_linear_speed, _x.max_rotational_speed, _x.pid_dist_offset, _x.target_offset, _x.only_collision_detection, _x.timeout, _x.pattern_type, _x.pattern_value, _x.only_track, _x.same_goal,) = _get_struct_f3Bd2B5dBd2i2B().unpack(str[start:end])
      self.clear_costmaps = bool(self.clear_costmaps)
      self.pause_command = bool(self.pause_command)
      self.continue_command = bool(self.continue_command)
      self.collision_detection = bool(self.collision_detection)
      self.collision_avoidance = bool(self.collision_avoidance)
      self.only_collision_detection = bool(self.only_collision_detection)
      self.only_track = bool(self.only_track)
      self.same_goal = bool(self.same_goal)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose_frame = str[start:end]
      _x = self
      start = end
      end += 93
      (_x.pose.x, _x.pose.y, _x.pose.theta, _x.offset.x, _x.offset.y, _x.offset.theta, _x.bar_length, _x.bar_distance, _x.shelf_leg_asymmetry_x, _x.tolerance, _x.path_type.path_type, _x.start_pose.header.seq, _x.start_pose.header.stamp.secs, _x.start_pose.header.stamp.nsecs,) = _get_struct_10dB3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.start_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.start_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.start_pose.pose.position.x, _x.start_pose.pose.position.y, _x.start_pose.pose.position.z, _x.start_pose.pose.orientation.x, _x.start_pose.pose.orientation.y, _x.start_pose.pose.orientation.z, _x.start_pose.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_10dB3I = None
def _get_struct_10dB3I():
    global _struct_10dB3I
    if _struct_10dB3I is None:
        _struct_10dB3I = struct.Struct("<10dB3I")
    return _struct_10dB3I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_2d3I = None
def _get_struct_2d3I():
    global _struct_2d3I
    if _struct_2d3I is None:
        _struct_2d3I = struct.Struct("<2d3I")
    return _struct_2d3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_7d = None
def _get_struct_7d():
    global _struct_7d
    if _struct_7d is None:
        _struct_7d = struct.Struct("<7d")
    return _struct_7d
_struct_f3Bd2B5dBd2i2B = None
def _get_struct_f3Bd2B5dBd2i2B():
    global _struct_f3Bd2B5dBd2i2B
    if _struct_f3Bd2B5dBd2i2B is None:
        _struct_f3Bd2B5dBd2i2B = struct.Struct("<f3Bd2B5dBd2i2B")
    return _struct_f3Bd2B5dBd2i2B
_struct_h3I = None
def _get_struct_h3I():
    global _struct_h3I
    if _struct_h3I is None:
        _struct_h3I = struct.Struct("<h3I")
    return _struct_h3I
