// Auto-generated. Do not edit!

// (in-package mir_actions.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class MirMoveBaseFeedback {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.state = null;
      this.base_position = null;
      this.current_goal = null;
      this.dist_to_goal = null;
      this.pose = null;
      this.marker_inversion = null;
    }
    else {
      if (initObj.hasOwnProperty('state')) {
        this.state = initObj.state
      }
      else {
        this.state = 0;
      }
      if (initObj.hasOwnProperty('base_position')) {
        this.base_position = initObj.base_position
      }
      else {
        this.base_position = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('current_goal')) {
        this.current_goal = initObj.current_goal
      }
      else {
        this.current_goal = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('dist_to_goal')) {
        this.dist_to_goal = initObj.dist_to_goal
      }
      else {
        this.dist_to_goal = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.Pose2D();
      }
      if (initObj.hasOwnProperty('marker_inversion')) {
        this.marker_inversion = initObj.marker_inversion
      }
      else {
        this.marker_inversion = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MirMoveBaseFeedback
    // Serialize message field [state]
    bufferOffset = _serializer.int8(obj.state, buffer, bufferOffset);
    // Serialize message field [base_position]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.base_position, buffer, bufferOffset);
    // Serialize message field [current_goal]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.current_goal, buffer, bufferOffset);
    // Serialize message field [dist_to_goal]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.dist_to_goal, buffer, bufferOffset);
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.Pose2D.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [marker_inversion]
    bufferOffset = _serializer.bool(obj.marker_inversion, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MirMoveBaseFeedback
    let len;
    let data = new MirMoveBaseFeedback(null);
    // Deserialize message field [state]
    data.state = _deserializer.int8(buffer, bufferOffset);
    // Deserialize message field [base_position]
    data.base_position = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [current_goal]
    data.current_goal = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [dist_to_goal]
    data.dist_to_goal = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.Pose2D.deserialize(buffer, bufferOffset);
    // Deserialize message field [marker_inversion]
    data.marker_inversion = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.base_position);
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.current_goal);
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.dist_to_goal);
    return length + 26;
  }

  static datatype() {
    // Returns string type for a message object
    return 'mir_actions/MirMoveBaseFeedback';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '91889a1bfc370b351d55faacdff14e74';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    #feedback
    #shared
    int8 NOT_READY = -1
    int8 UNKNOWN = -2
    int8 WAITING_FOR_FLEET = -3
    int8 COLLISION = -4
    
    #global move states
    int8 PLANNING = 0
    int8 CONTROLLING = 1
    int8 CLEARING = 2
    
    #relative move states
    int8 DOCKING = 3
    
    #shared feedback
    int8 state
    
    #global move feedback
    geometry_msgs/PoseStamped base_position
    
    #relative move feedback
    geometry_msgs/PoseStamped current_goal
    geometry_msgs/PoseStamped dist_to_goal
    
    #docking move feedback
    geometry_msgs/Pose2D pose
    bool marker_inversion
    
    #path_types
        #reverse_trolly
    int8 MOVING_FORWARD = 10
    int8 MOVING_BACKWARD = 11
    
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: geometry_msgs/Pose2D
    # Deprecated
    # Please use the full 3D pose.
    
    # In general our recommendation is to use a full 3D representation of everything and for 2D specific applications make the appropriate projections into the plane for their calculations but optimally will preserve the 3D information during processing.
    
    # If we have parallel copies of 2D datatypes every UI and other pipeline will end up needing to have dual interfaces to plot everything. And you will end up with not being able to use 3D tools for 2D use cases even if they're completely valid, as you'd have to reimplement it with different inputs and outputs. It's not particularly hard to plot the 2D pose or compute the yaw error for the Pose message and there are already tools and libraries that can do this for you.
    
    
    # This expresses a position and orientation on a 2D manifold.
    
    float64 x
    float64 y
    float64 theta
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MirMoveBaseFeedback(null);
    if (msg.state !== undefined) {
      resolved.state = msg.state;
    }
    else {
      resolved.state = 0
    }

    if (msg.base_position !== undefined) {
      resolved.base_position = geometry_msgs.msg.PoseStamped.Resolve(msg.base_position)
    }
    else {
      resolved.base_position = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.current_goal !== undefined) {
      resolved.current_goal = geometry_msgs.msg.PoseStamped.Resolve(msg.current_goal)
    }
    else {
      resolved.current_goal = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.dist_to_goal !== undefined) {
      resolved.dist_to_goal = geometry_msgs.msg.PoseStamped.Resolve(msg.dist_to_goal)
    }
    else {
      resolved.dist_to_goal = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.Pose2D.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.Pose2D()
    }

    if (msg.marker_inversion !== undefined) {
      resolved.marker_inversion = msg.marker_inversion;
    }
    else {
      resolved.marker_inversion = false
    }

    return resolved;
    }
};

// Constants for message
MirMoveBaseFeedback.Constants = {
  NOT_READY: -1,
  UNKNOWN: -2,
  WAITING_FOR_FLEET: -3,
  COLLISION: -4,
  PLANNING: 0,
  CONTROLLING: 1,
  CLEARING: 2,
  DOCKING: 3,
  MOVING_FORWARD: 10,
  MOVING_BACKWARD: 11,
}

module.exports = MirMoveBaseFeedback;
